import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { DeleteEndpointResponseFilterSensitiveLog, } from "../models/models_0";
import { de_DeleteEndpointCommand, se_DeleteEndpointCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class DeleteEndpointCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AmazonDMSv20160101", "DeleteEndpoint", {})
    .n("DatabaseMigrationServiceClient", "DeleteEndpointCommand")
    .f(void 0, DeleteEndpointResponseFilterSensitiveLog)
    .ser(se_DeleteEndpointCommand)
    .de(de_DeleteEndpointCommand)
    .build() {
}
