import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_UpdateSubscriptionsToEventBridgeCommand, se_UpdateSubscriptionsToEventBridgeCommand, } from "../protocols/Aws_json1_1";
export { $Command };
export class UpdateSubscriptionsToEventBridgeCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AmazonDMSv20160101", "UpdateSubscriptionsToEventBridge", {})
    .n("DatabaseMigrationServiceClient", "UpdateSubscriptionsToEventBridgeCommand")
    .f(void 0, void 0)
    .ser(se_UpdateSubscriptionsToEventBridgeCommand)
    .de(de_UpdateSubscriptionsToEventBridgeCommand)
    .build() {
}
