import { awsExpectUnion as __expectUnion, loadRestJsonErrorCode, parseJsonBody as parseBody, parseJsonErrorBody as parseErrorBody, } from "@aws-sdk/core";
import { HttpRequest as __HttpRequest } from "@smithy/protocol-http";
import { _json, collectBody, decorateServiceException as __decorateServiceException, expectBoolean as __expectBoolean, expectInt32 as __expectInt32, expectLong as __expectLong, expectNonNull as __expectNonNull, expectNumber as __expectNumber, expectString as __expectString, limitedParseDouble as __limitedParseDouble, parseEpochTimestamp as __parseEpochTimestamp, parseRfc3339DateTimeWithOffset as __parseRfc3339DateTimeWithOffset, take, withBaseException, } from "@smithy/smithy-client";
import { DatabaseMigrationServiceServiceException as __BaseException } from "../models/DatabaseMigrationServiceServiceException";
import { AccessDeniedFault, CollectorNotFoundFault, InsufficientResourceCapacityFault, InvalidCertificateFault, InvalidOperationFault, InvalidResourceStateFault, InvalidSubnet, KMSAccessDeniedFault, KMSDisabledFault, KMSInvalidStateFault, KMSKeyNotAccessibleFault, KMSNotFoundFault, KMSThrottlingFault, ReplicationSubnetGroupDoesNotCoverEnoughAZs, ResourceAlreadyExistsFault, ResourceNotFoundFault, ResourceQuotaExceededFault, S3AccessDeniedFault, S3ResourceNotFoundFault, SNSInvalidTopicFault, SNSNoAuthorizationFault, StorageQuotaExceededFault, } from "../models/models_0";
import { KMSFault, SubnetAlreadyInUse, UpgradeDependencyFailureFault, } from "../models/models_1";
export const se_AddTagsToResourceCommand = async (input, context) => {
    const headers = sharedHeaders("AddTagsToResource");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ApplyPendingMaintenanceActionCommand = async (input, context) => {
    const headers = sharedHeaders("ApplyPendingMaintenanceAction");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_BatchStartRecommendationsCommand = async (input, context) => {
    const headers = sharedHeaders("BatchStartRecommendations");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CancelReplicationTaskAssessmentRunCommand = async (input, context) => {
    const headers = sharedHeaders("CancelReplicationTaskAssessmentRun");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateDataProviderCommand = async (input, context) => {
    const headers = sharedHeaders("CreateDataProvider");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateEndpointCommand = async (input, context) => {
    const headers = sharedHeaders("CreateEndpoint");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateEventSubscriptionCommand = async (input, context) => {
    const headers = sharedHeaders("CreateEventSubscription");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateFleetAdvisorCollectorCommand = async (input, context) => {
    const headers = sharedHeaders("CreateFleetAdvisorCollector");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateInstanceProfileCommand = async (input, context) => {
    const headers = sharedHeaders("CreateInstanceProfile");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateMigrationProjectCommand = async (input, context) => {
    const headers = sharedHeaders("CreateMigrationProject");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateReplicationConfigCommand = async (input, context) => {
    const headers = sharedHeaders("CreateReplicationConfig");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateReplicationInstanceCommand = async (input, context) => {
    const headers = sharedHeaders("CreateReplicationInstance");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateReplicationSubnetGroupCommand = async (input, context) => {
    const headers = sharedHeaders("CreateReplicationSubnetGroup");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateReplicationTaskCommand = async (input, context) => {
    const headers = sharedHeaders("CreateReplicationTask");
    let body;
    body = JSON.stringify(se_CreateReplicationTaskMessage(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteCertificateCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteCertificate");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteConnectionCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteConnection");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteDataProviderCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteDataProvider");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteEndpointCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteEndpoint");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteEventSubscriptionCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteEventSubscription");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteFleetAdvisorCollectorCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteFleetAdvisorCollector");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteFleetAdvisorDatabasesCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteFleetAdvisorDatabases");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteInstanceProfileCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteInstanceProfile");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteMigrationProjectCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteMigrationProject");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteReplicationConfigCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteReplicationConfig");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteReplicationInstanceCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteReplicationInstance");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteReplicationSubnetGroupCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteReplicationSubnetGroup");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteReplicationTaskCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteReplicationTask");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteReplicationTaskAssessmentRunCommand = async (input, context) => {
    const headers = sharedHeaders("DeleteReplicationTaskAssessmentRun");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeAccountAttributesCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeAccountAttributes");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeApplicableIndividualAssessmentsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeApplicableIndividualAssessments");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeCertificatesCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeCertificates");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeConnectionsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeConnections");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeConversionConfigurationCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeConversionConfiguration");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeDataProvidersCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeDataProviders");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeEndpointsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeEndpoints");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeEndpointSettingsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeEndpointSettings");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeEndpointTypesCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeEndpointTypes");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeEngineVersionsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeEngineVersions");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeEventCategoriesCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeEventCategories");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeEventsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeEvents");
    let body;
    body = JSON.stringify(se_DescribeEventsMessage(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeEventSubscriptionsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeEventSubscriptions");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeExtensionPackAssociationsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeExtensionPackAssociations");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeFleetAdvisorCollectorsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeFleetAdvisorCollectors");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeFleetAdvisorDatabasesCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeFleetAdvisorDatabases");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeFleetAdvisorLsaAnalysisCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeFleetAdvisorLsaAnalysis");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeFleetAdvisorSchemaObjectSummaryCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeFleetAdvisorSchemaObjectSummary");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeFleetAdvisorSchemasCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeFleetAdvisorSchemas");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeInstanceProfilesCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeInstanceProfiles");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeMetadataModelAssessmentsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeMetadataModelAssessments");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeMetadataModelConversionsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeMetadataModelConversions");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeMetadataModelExportsAsScriptCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeMetadataModelExportsAsScript");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeMetadataModelExportsToTargetCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeMetadataModelExportsToTarget");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeMetadataModelImportsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeMetadataModelImports");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeMigrationProjectsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeMigrationProjects");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeOrderableReplicationInstancesCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeOrderableReplicationInstances");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribePendingMaintenanceActionsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribePendingMaintenanceActions");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeRecommendationLimitationsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeRecommendationLimitations");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeRecommendationsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeRecommendations");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeRefreshSchemasStatusCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeRefreshSchemasStatus");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationConfigsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplicationConfigs");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationInstancesCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplicationInstances");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationInstanceTaskLogsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplicationInstanceTaskLogs");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplications");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationSubnetGroupsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplicationSubnetGroups");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationTableStatisticsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplicationTableStatistics");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationTaskAssessmentResultsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplicationTaskAssessmentResults");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationTaskAssessmentRunsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplicationTaskAssessmentRuns");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationTaskIndividualAssessmentsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplicationTaskIndividualAssessments");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeReplicationTasksCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeReplicationTasks");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeSchemasCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeSchemas");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeTableStatisticsCommand = async (input, context) => {
    const headers = sharedHeaders("DescribeTableStatistics");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ExportMetadataModelAssessmentCommand = async (input, context) => {
    const headers = sharedHeaders("ExportMetadataModelAssessment");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ImportCertificateCommand = async (input, context) => {
    const headers = sharedHeaders("ImportCertificate");
    let body;
    body = JSON.stringify(se_ImportCertificateMessage(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ListTagsForResourceCommand = async (input, context) => {
    const headers = sharedHeaders("ListTagsForResource");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyConversionConfigurationCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyConversionConfiguration");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyDataProviderCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyDataProvider");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyEndpointCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyEndpoint");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyEventSubscriptionCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyEventSubscription");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyInstanceProfileCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyInstanceProfile");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyMigrationProjectCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyMigrationProject");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyReplicationConfigCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyReplicationConfig");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyReplicationInstanceCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyReplicationInstance");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyReplicationSubnetGroupCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyReplicationSubnetGroup");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ModifyReplicationTaskCommand = async (input, context) => {
    const headers = sharedHeaders("ModifyReplicationTask");
    let body;
    body = JSON.stringify(se_ModifyReplicationTaskMessage(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_MoveReplicationTaskCommand = async (input, context) => {
    const headers = sharedHeaders("MoveReplicationTask");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_RebootReplicationInstanceCommand = async (input, context) => {
    const headers = sharedHeaders("RebootReplicationInstance");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_RefreshSchemasCommand = async (input, context) => {
    const headers = sharedHeaders("RefreshSchemas");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ReloadReplicationTablesCommand = async (input, context) => {
    const headers = sharedHeaders("ReloadReplicationTables");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ReloadTablesCommand = async (input, context) => {
    const headers = sharedHeaders("ReloadTables");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_RemoveTagsFromResourceCommand = async (input, context) => {
    const headers = sharedHeaders("RemoveTagsFromResource");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_RunFleetAdvisorLsaAnalysisCommand = async (input, context) => {
    const headers = sharedHeaders("RunFleetAdvisorLsaAnalysis");
    const body = "{}";
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartExtensionPackAssociationCommand = async (input, context) => {
    const headers = sharedHeaders("StartExtensionPackAssociation");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartMetadataModelAssessmentCommand = async (input, context) => {
    const headers = sharedHeaders("StartMetadataModelAssessment");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartMetadataModelConversionCommand = async (input, context) => {
    const headers = sharedHeaders("StartMetadataModelConversion");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartMetadataModelExportAsScriptCommand = async (input, context) => {
    const headers = sharedHeaders("StartMetadataModelExportAsScript");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartMetadataModelExportToTargetCommand = async (input, context) => {
    const headers = sharedHeaders("StartMetadataModelExportToTarget");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartMetadataModelImportCommand = async (input, context) => {
    const headers = sharedHeaders("StartMetadataModelImport");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartRecommendationsCommand = async (input, context) => {
    const headers = sharedHeaders("StartRecommendations");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartReplicationCommand = async (input, context) => {
    const headers = sharedHeaders("StartReplication");
    let body;
    body = JSON.stringify(se_StartReplicationMessage(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartReplicationTaskCommand = async (input, context) => {
    const headers = sharedHeaders("StartReplicationTask");
    let body;
    body = JSON.stringify(se_StartReplicationTaskMessage(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartReplicationTaskAssessmentCommand = async (input, context) => {
    const headers = sharedHeaders("StartReplicationTaskAssessment");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartReplicationTaskAssessmentRunCommand = async (input, context) => {
    const headers = sharedHeaders("StartReplicationTaskAssessmentRun");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StopReplicationCommand = async (input, context) => {
    const headers = sharedHeaders("StopReplication");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StopReplicationTaskCommand = async (input, context) => {
    const headers = sharedHeaders("StopReplicationTask");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_TestConnectionCommand = async (input, context) => {
    const headers = sharedHeaders("TestConnection");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_UpdateSubscriptionsToEventBridgeCommand = async (input, context) => {
    const headers = sharedHeaders("UpdateSubscriptionsToEventBridge");
    let body;
    body = JSON.stringify(_json(input));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const de_AddTagsToResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ApplyPendingMaintenanceActionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ApplyPendingMaintenanceActionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_BatchStartRecommendationsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CancelReplicationTaskAssessmentRunCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CancelReplicationTaskAssessmentRunResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateDataProviderCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CreateDataProviderResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateEndpointCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateEventSubscriptionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateFleetAdvisorCollectorCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateInstanceProfileCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CreateInstanceProfileResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateMigrationProjectCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CreateMigrationProjectResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateReplicationConfigCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CreateReplicationConfigResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateReplicationInstanceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CreateReplicationInstanceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateReplicationSubnetGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_CreateReplicationTaskCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CreateReplicationTaskResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteCertificateCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteCertificateResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteConnectionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteDataProviderCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteDataProviderResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteEndpointCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteEventSubscriptionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteFleetAdvisorCollectorCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    await collectBody(output.body, context);
    const response = {
        $metadata: deserializeMetadata(output),
    };
    return response;
};
export const de_DeleteFleetAdvisorDatabasesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteInstanceProfileCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteInstanceProfileResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteMigrationProjectCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteMigrationProjectResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteReplicationConfigCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteReplicationConfigResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteReplicationInstanceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteReplicationInstanceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteReplicationSubnetGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteReplicationTaskCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteReplicationTaskResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DeleteReplicationTaskAssessmentRunCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteReplicationTaskAssessmentRunResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeAccountAttributesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeApplicableIndividualAssessmentsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeCertificatesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeCertificatesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeConnectionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeConversionConfigurationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeDataProvidersCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeDataProvidersResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeEndpointsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeEndpointSettingsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeEndpointTypesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeEngineVersionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeEngineVersionsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeEventCategoriesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeEventsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeEventsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeEventSubscriptionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeExtensionPackAssociationsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeFleetAdvisorCollectorsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeFleetAdvisorDatabasesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeFleetAdvisorLsaAnalysisCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeFleetAdvisorSchemaObjectSummaryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeFleetAdvisorSchemasCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeFleetAdvisorSchemasResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeInstanceProfilesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeInstanceProfilesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeMetadataModelAssessmentsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeMetadataModelConversionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeMetadataModelExportsAsScriptCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeMetadataModelExportsToTargetCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeMetadataModelImportsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeMigrationProjectsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeMigrationProjectsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeOrderableReplicationInstancesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribePendingMaintenanceActionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribePendingMaintenanceActionsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeRecommendationLimitationsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeRecommendationsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeRecommendationsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeRefreshSchemasStatusCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeRefreshSchemasStatusResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationConfigsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeReplicationConfigsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationInstancesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeReplicationInstancesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationInstanceTaskLogsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeReplicationsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationSubnetGroupsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationTableStatisticsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeReplicationTableStatisticsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationTaskAssessmentResultsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeReplicationTaskAssessmentResultsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationTaskAssessmentRunsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeReplicationTaskAssessmentRunsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationTaskIndividualAssessmentsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeReplicationTaskIndividualAssessmentsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeReplicationTasksCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeReplicationTasksResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeSchemasCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_DescribeTableStatisticsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeTableStatisticsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ExportMetadataModelAssessmentCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ImportCertificateCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ImportCertificateResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyConversionConfigurationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyDataProviderCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ModifyDataProviderResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyEndpointCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyEventSubscriptionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyInstanceProfileCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ModifyInstanceProfileResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyMigrationProjectCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ModifyMigrationProjectResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyReplicationConfigCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ModifyReplicationConfigResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyReplicationInstanceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ModifyReplicationInstanceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyReplicationSubnetGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ModifyReplicationTaskCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ModifyReplicationTaskResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_MoveReplicationTaskCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_MoveReplicationTaskResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_RebootReplicationInstanceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_RebootReplicationInstanceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_RefreshSchemasCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_RefreshSchemasResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ReloadReplicationTablesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_ReloadTablesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_RemoveTagsFromResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_RunFleetAdvisorLsaAnalysisCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartExtensionPackAssociationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartMetadataModelAssessmentCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartMetadataModelConversionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartMetadataModelExportAsScriptCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartMetadataModelExportToTargetCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartMetadataModelImportCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartRecommendationsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    await collectBody(output.body, context);
    const response = {
        $metadata: deserializeMetadata(output),
    };
    return response;
};
export const de_StartReplicationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_StartReplicationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartReplicationTaskCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_StartReplicationTaskResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartReplicationTaskAssessmentCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_StartReplicationTaskAssessmentResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StartReplicationTaskAssessmentRunCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_StartReplicationTaskAssessmentRunResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StopReplicationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_StopReplicationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_StopReplicationTaskCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_StopReplicationTaskResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_TestConnectionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
export const de_UpdateSubscriptionsToEventBridgeCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = _json(data);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return response;
};
const de_CommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ResourceNotFoundFault":
        case "com.amazonaws.databasemigrationservice#ResourceNotFoundFault":
            throw await de_ResourceNotFoundFaultRes(parsedOutput, context);
        case "AccessDeniedFault":
        case "com.amazonaws.databasemigrationservice#AccessDeniedFault":
            throw await de_AccessDeniedFaultRes(parsedOutput, context);
        case "InvalidResourceStateFault":
        case "com.amazonaws.databasemigrationservice#InvalidResourceStateFault":
            throw await de_InvalidResourceStateFaultRes(parsedOutput, context);
        case "ResourceAlreadyExistsFault":
        case "com.amazonaws.databasemigrationservice#ResourceAlreadyExistsFault":
            throw await de_ResourceAlreadyExistsFaultRes(parsedOutput, context);
        case "ResourceQuotaExceededFault":
        case "com.amazonaws.databasemigrationservice#ResourceQuotaExceededFault":
            throw await de_ResourceQuotaExceededFaultRes(parsedOutput, context);
        case "KMSKeyNotAccessibleFault":
        case "com.amazonaws.databasemigrationservice#KMSKeyNotAccessibleFault":
            throw await de_KMSKeyNotAccessibleFaultRes(parsedOutput, context);
        case "S3AccessDeniedFault":
        case "com.amazonaws.databasemigrationservice#S3AccessDeniedFault":
            throw await de_S3AccessDeniedFaultRes(parsedOutput, context);
        case "KMSAccessDeniedFault":
        case "com.amazonaws.databasemigrationservice#KMSAccessDeniedFault":
            throw await de_KMSAccessDeniedFaultRes(parsedOutput, context);
        case "KMSDisabledFault":
        case "com.amazonaws.databasemigrationservice#KMSDisabledFault":
            throw await de_KMSDisabledFaultRes(parsedOutput, context);
        case "KMSInvalidStateFault":
        case "com.amazonaws.databasemigrationservice#KMSInvalidStateFault":
            throw await de_KMSInvalidStateFaultRes(parsedOutput, context);
        case "KMSNotFoundFault":
        case "com.amazonaws.databasemigrationservice#KMSNotFoundFault":
            throw await de_KMSNotFoundFaultRes(parsedOutput, context);
        case "KMSThrottlingFault":
        case "com.amazonaws.databasemigrationservice#KMSThrottlingFault":
            throw await de_KMSThrottlingFaultRes(parsedOutput, context);
        case "SNSInvalidTopicFault":
        case "com.amazonaws.databasemigrationservice#SNSInvalidTopicFault":
            throw await de_SNSInvalidTopicFaultRes(parsedOutput, context);
        case "SNSNoAuthorizationFault":
        case "com.amazonaws.databasemigrationservice#SNSNoAuthorizationFault":
            throw await de_SNSNoAuthorizationFaultRes(parsedOutput, context);
        case "S3ResourceNotFoundFault":
        case "com.amazonaws.databasemigrationservice#S3ResourceNotFoundFault":
            throw await de_S3ResourceNotFoundFaultRes(parsedOutput, context);
        case "InvalidSubnet":
        case "com.amazonaws.databasemigrationservice#InvalidSubnet":
            throw await de_InvalidSubnetRes(parsedOutput, context);
        case "ReplicationSubnetGroupDoesNotCoverEnoughAZs":
        case "com.amazonaws.databasemigrationservice#ReplicationSubnetGroupDoesNotCoverEnoughAZs":
            throw await de_ReplicationSubnetGroupDoesNotCoverEnoughAZsRes(parsedOutput, context);
        case "InsufficientResourceCapacityFault":
        case "com.amazonaws.databasemigrationservice#InsufficientResourceCapacityFault":
            throw await de_InsufficientResourceCapacityFaultRes(parsedOutput, context);
        case "StorageQuotaExceededFault":
        case "com.amazonaws.databasemigrationservice#StorageQuotaExceededFault":
            throw await de_StorageQuotaExceededFaultRes(parsedOutput, context);
        case "CollectorNotFoundFault":
        case "com.amazonaws.databasemigrationservice#CollectorNotFoundFault":
            throw await de_CollectorNotFoundFaultRes(parsedOutput, context);
        case "InvalidOperationFault":
        case "com.amazonaws.databasemigrationservice#InvalidOperationFault":
            throw await de_InvalidOperationFaultRes(parsedOutput, context);
        case "InvalidCertificateFault":
        case "com.amazonaws.databasemigrationservice#InvalidCertificateFault":
            throw await de_InvalidCertificateFaultRes(parsedOutput, context);
        case "UpgradeDependencyFailureFault":
        case "com.amazonaws.databasemigrationservice#UpgradeDependencyFailureFault":
            throw await de_UpgradeDependencyFailureFaultRes(parsedOutput, context);
        case "SubnetAlreadyInUse":
        case "com.amazonaws.databasemigrationservice#SubnetAlreadyInUse":
            throw await de_SubnetAlreadyInUseRes(parsedOutput, context);
        case "KMSFault":
        case "com.amazonaws.databasemigrationservice#KMSFault":
            throw await de_KMSFaultRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_AccessDeniedFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new AccessDeniedFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_CollectorNotFoundFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new CollectorNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_InsufficientResourceCapacityFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new InsufficientResourceCapacityFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_InvalidCertificateFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new InvalidCertificateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_InvalidOperationFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new InvalidOperationFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_InvalidResourceStateFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new InvalidResourceStateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_InvalidSubnetRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new InvalidSubnet({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_KMSAccessDeniedFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new KMSAccessDeniedFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_KMSDisabledFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new KMSDisabledFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_KMSFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new KMSFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_KMSInvalidStateFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new KMSInvalidStateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_KMSKeyNotAccessibleFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new KMSKeyNotAccessibleFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_KMSNotFoundFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new KMSNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_KMSThrottlingFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new KMSThrottlingFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_ReplicationSubnetGroupDoesNotCoverEnoughAZsRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new ReplicationSubnetGroupDoesNotCoverEnoughAZs({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_ResourceAlreadyExistsFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new ResourceAlreadyExistsFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_ResourceNotFoundFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new ResourceNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_ResourceQuotaExceededFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new ResourceQuotaExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_S3AccessDeniedFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new S3AccessDeniedFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_S3ResourceNotFoundFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new S3ResourceNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_SNSInvalidTopicFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new SNSInvalidTopicFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_SNSNoAuthorizationFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new SNSNoAuthorizationFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_StorageQuotaExceededFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new StorageQuotaExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_SubnetAlreadyInUseRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new SubnetAlreadyInUse({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_UpgradeDependencyFailureFaultRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = _json(body);
    const exception = new UpgradeDependencyFailureFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const se_CreateReplicationTaskMessage = (input, context) => {
    return take(input, {
        CdcStartPosition: [],
        CdcStartTime: (_) => Math.round(_.getTime() / 1000),
        CdcStopPosition: [],
        MigrationType: [],
        ReplicationInstanceArn: [],
        ReplicationTaskIdentifier: [],
        ReplicationTaskSettings: [],
        ResourceIdentifier: [],
        SourceEndpointArn: [],
        TableMappings: [],
        Tags: _json,
        TargetEndpointArn: [],
        TaskData: [],
    });
};
const se_DescribeEventsMessage = (input, context) => {
    return take(input, {
        Duration: [],
        EndTime: (_) => Math.round(_.getTime() / 1000),
        EventCategories: _json,
        Filters: _json,
        Marker: [],
        MaxRecords: [],
        SourceIdentifier: [],
        SourceType: [],
        StartTime: (_) => Math.round(_.getTime() / 1000),
    });
};
const se_ImportCertificateMessage = (input, context) => {
    return take(input, {
        CertificateIdentifier: [],
        CertificatePem: [],
        CertificateWallet: context.base64Encoder,
        Tags: _json,
    });
};
const se_ModifyReplicationTaskMessage = (input, context) => {
    return take(input, {
        CdcStartPosition: [],
        CdcStartTime: (_) => Math.round(_.getTime() / 1000),
        CdcStopPosition: [],
        MigrationType: [],
        ReplicationTaskArn: [],
        ReplicationTaskIdentifier: [],
        ReplicationTaskSettings: [],
        TableMappings: [],
        TaskData: [],
    });
};
const se_StartReplicationMessage = (input, context) => {
    return take(input, {
        CdcStartPosition: [],
        CdcStartTime: (_) => Math.round(_.getTime() / 1000),
        CdcStopPosition: [],
        ReplicationConfigArn: [],
        StartReplicationType: [],
    });
};
const se_StartReplicationTaskMessage = (input, context) => {
    return take(input, {
        CdcStartPosition: [],
        CdcStartTime: (_) => Math.round(_.getTime() / 1000),
        CdcStopPosition: [],
        ReplicationTaskArn: [],
        StartReplicationTaskType: [],
    });
};
const de_ApplyPendingMaintenanceActionResponse = (output, context) => {
    return take(output, {
        ResourcePendingMaintenanceActions: (_) => de_ResourcePendingMaintenanceActions(_, context),
    });
};
const de_CancelReplicationTaskAssessmentRunResponse = (output, context) => {
    return take(output, {
        ReplicationTaskAssessmentRun: (_) => de_ReplicationTaskAssessmentRun(_, context),
    });
};
const de_Certificate = (output, context) => {
    return take(output, {
        CertificateArn: __expectString,
        CertificateCreationDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        CertificateIdentifier: __expectString,
        CertificateOwner: __expectString,
        CertificatePem: __expectString,
        CertificateWallet: context.base64Decoder,
        KeyLength: __expectInt32,
        SigningAlgorithm: __expectString,
        ValidFromDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ValidToDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
    });
};
const de_CertificateList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_Certificate(entry, context);
    });
    return retVal;
};
const de_CreateDataProviderResponse = (output, context) => {
    return take(output, {
        DataProvider: (_) => de_DataProvider(_, context),
    });
};
const de_CreateInstanceProfileResponse = (output, context) => {
    return take(output, {
        InstanceProfile: (_) => de_InstanceProfile(_, context),
    });
};
const de_CreateMigrationProjectResponse = (output, context) => {
    return take(output, {
        MigrationProject: (_) => de_MigrationProject(_, context),
    });
};
const de_CreateReplicationConfigResponse = (output, context) => {
    return take(output, {
        ReplicationConfig: (_) => de_ReplicationConfig(_, context),
    });
};
const de_CreateReplicationInstanceResponse = (output, context) => {
    return take(output, {
        ReplicationInstance: (_) => de_ReplicationInstance(_, context),
    });
};
const de_CreateReplicationTaskResponse = (output, context) => {
    return take(output, {
        ReplicationTask: (_) => de_ReplicationTask(_, context),
    });
};
const de_DataProvider = (output, context) => {
    return take(output, {
        DataProviderArn: __expectString,
        DataProviderCreationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        DataProviderName: __expectString,
        Description: __expectString,
        Engine: __expectString,
        Settings: (_) => _json(__expectUnion(_)),
    });
};
const de_DataProviderList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_DataProvider(entry, context);
    });
    return retVal;
};
const de_DeleteCertificateResponse = (output, context) => {
    return take(output, {
        Certificate: (_) => de_Certificate(_, context),
    });
};
const de_DeleteDataProviderResponse = (output, context) => {
    return take(output, {
        DataProvider: (_) => de_DataProvider(_, context),
    });
};
const de_DeleteInstanceProfileResponse = (output, context) => {
    return take(output, {
        InstanceProfile: (_) => de_InstanceProfile(_, context),
    });
};
const de_DeleteMigrationProjectResponse = (output, context) => {
    return take(output, {
        MigrationProject: (_) => de_MigrationProject(_, context),
    });
};
const de_DeleteReplicationConfigResponse = (output, context) => {
    return take(output, {
        ReplicationConfig: (_) => de_ReplicationConfig(_, context),
    });
};
const de_DeleteReplicationInstanceResponse = (output, context) => {
    return take(output, {
        ReplicationInstance: (_) => de_ReplicationInstance(_, context),
    });
};
const de_DeleteReplicationTaskAssessmentRunResponse = (output, context) => {
    return take(output, {
        ReplicationTaskAssessmentRun: (_) => de_ReplicationTaskAssessmentRun(_, context),
    });
};
const de_DeleteReplicationTaskResponse = (output, context) => {
    return take(output, {
        ReplicationTask: (_) => de_ReplicationTask(_, context),
    });
};
const de_DescribeCertificatesResponse = (output, context) => {
    return take(output, {
        Certificates: (_) => de_CertificateList(_, context),
        Marker: __expectString,
    });
};
const de_DescribeDataProvidersResponse = (output, context) => {
    return take(output, {
        DataProviders: (_) => de_DataProviderList(_, context),
        Marker: __expectString,
    });
};
const de_DescribeEngineVersionsResponse = (output, context) => {
    return take(output, {
        EngineVersions: (_) => de_EngineVersionList(_, context),
        Marker: __expectString,
    });
};
const de_DescribeEventsResponse = (output, context) => {
    return take(output, {
        Events: (_) => de_EventList(_, context),
        Marker: __expectString,
    });
};
const de_DescribeFleetAdvisorSchemasResponse = (output, context) => {
    return take(output, {
        FleetAdvisorSchemas: (_) => de_FleetAdvisorSchemaList(_, context),
        NextToken: __expectString,
    });
};
const de_DescribeInstanceProfilesResponse = (output, context) => {
    return take(output, {
        InstanceProfiles: (_) => de_InstanceProfileList(_, context),
        Marker: __expectString,
    });
};
const de_DescribeMigrationProjectsResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        MigrationProjects: (_) => de_MigrationProjectList(_, context),
    });
};
const de_DescribePendingMaintenanceActionsResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        PendingMaintenanceActions: (_) => de_PendingMaintenanceActions(_, context),
    });
};
const de_DescribeRecommendationsResponse = (output, context) => {
    return take(output, {
        NextToken: __expectString,
        Recommendations: (_) => de_RecommendationList(_, context),
    });
};
const de_DescribeRefreshSchemasStatusResponse = (output, context) => {
    return take(output, {
        RefreshSchemasStatus: (_) => de_RefreshSchemasStatus(_, context),
    });
};
const de_DescribeReplicationConfigsResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        ReplicationConfigs: (_) => de_ReplicationConfigList(_, context),
    });
};
const de_DescribeReplicationInstancesResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        ReplicationInstances: (_) => de_ReplicationInstanceList(_, context),
    });
};
const de_DescribeReplicationsResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        Replications: (_) => de_ReplicationList(_, context),
    });
};
const de_DescribeReplicationTableStatisticsResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        ReplicationConfigArn: __expectString,
        ReplicationTableStatistics: (_) => de_ReplicationTableStatisticsList(_, context),
    });
};
const de_DescribeReplicationTaskAssessmentResultsResponse = (output, context) => {
    return take(output, {
        BucketName: __expectString,
        Marker: __expectString,
        ReplicationTaskAssessmentResults: (_) => de_ReplicationTaskAssessmentResultList(_, context),
    });
};
const de_DescribeReplicationTaskAssessmentRunsResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        ReplicationTaskAssessmentRuns: (_) => de_ReplicationTaskAssessmentRunList(_, context),
    });
};
const de_DescribeReplicationTaskIndividualAssessmentsResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        ReplicationTaskIndividualAssessments: (_) => de_ReplicationTaskIndividualAssessmentList(_, context),
    });
};
const de_DescribeReplicationTasksResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        ReplicationTasks: (_) => de_ReplicationTaskList(_, context),
    });
};
const de_DescribeTableStatisticsResponse = (output, context) => {
    return take(output, {
        Marker: __expectString,
        ReplicationTaskArn: __expectString,
        TableStatistics: (_) => de_TableStatisticsList(_, context),
    });
};
const de_EngineVersion = (output, context) => {
    return take(output, {
        AutoUpgradeDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        AvailableUpgrades: _json,
        DeprecationDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ForceUpgradeDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        LaunchDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Lifecycle: __expectString,
        ReleaseStatus: __expectString,
        Version: __expectString,
    });
};
const de_EngineVersionList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_EngineVersion(entry, context);
    });
    return retVal;
};
const de_Event = (output, context) => {
    return take(output, {
        Date: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        EventCategories: _json,
        Message: __expectString,
        SourceIdentifier: __expectString,
        SourceType: __expectString,
    });
};
const de_EventList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_Event(entry, context);
    });
    return retVal;
};
const de_FleetAdvisorSchemaList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_SchemaResponse(entry, context);
    });
    return retVal;
};
const de_ImportCertificateResponse = (output, context) => {
    return take(output, {
        Certificate: (_) => de_Certificate(_, context),
    });
};
const de_InstanceProfile = (output, context) => {
    return take(output, {
        AvailabilityZone: __expectString,
        Description: __expectString,
        InstanceProfileArn: __expectString,
        InstanceProfileCreationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        InstanceProfileName: __expectString,
        KmsKeyArn: __expectString,
        NetworkType: __expectString,
        PubliclyAccessible: __expectBoolean,
        SubnetGroupIdentifier: __expectString,
        VpcSecurityGroups: _json,
    });
};
const de_InstanceProfileList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_InstanceProfile(entry, context);
    });
    return retVal;
};
const de_MigrationProject = (output, context) => {
    return take(output, {
        Description: __expectString,
        InstanceProfileArn: __expectString,
        InstanceProfileName: __expectString,
        MigrationProjectArn: __expectString,
        MigrationProjectCreationTime: (_) => __expectNonNull(__parseRfc3339DateTimeWithOffset(_)),
        MigrationProjectName: __expectString,
        SchemaConversionApplicationAttributes: _json,
        SourceDataProviderDescriptors: _json,
        TargetDataProviderDescriptors: _json,
        TransformationRules: __expectString,
    });
};
const de_MigrationProjectList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_MigrationProject(entry, context);
    });
    return retVal;
};
const de_ModifyDataProviderResponse = (output, context) => {
    return take(output, {
        DataProvider: (_) => de_DataProvider(_, context),
    });
};
const de_ModifyInstanceProfileResponse = (output, context) => {
    return take(output, {
        InstanceProfile: (_) => de_InstanceProfile(_, context),
    });
};
const de_ModifyMigrationProjectResponse = (output, context) => {
    return take(output, {
        MigrationProject: (_) => de_MigrationProject(_, context),
    });
};
const de_ModifyReplicationConfigResponse = (output, context) => {
    return take(output, {
        ReplicationConfig: (_) => de_ReplicationConfig(_, context),
    });
};
const de_ModifyReplicationInstanceResponse = (output, context) => {
    return take(output, {
        ReplicationInstance: (_) => de_ReplicationInstance(_, context),
    });
};
const de_ModifyReplicationTaskResponse = (output, context) => {
    return take(output, {
        ReplicationTask: (_) => de_ReplicationTask(_, context),
    });
};
const de_MoveReplicationTaskResponse = (output, context) => {
    return take(output, {
        ReplicationTask: (_) => de_ReplicationTask(_, context),
    });
};
const de_PendingMaintenanceAction = (output, context) => {
    return take(output, {
        Action: __expectString,
        AutoAppliedAfterDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        CurrentApplyDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ForcedApplyDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        OptInStatus: __expectString,
    });
};
const de_PendingMaintenanceActionDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_PendingMaintenanceAction(entry, context);
    });
    return retVal;
};
const de_PendingMaintenanceActions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ResourcePendingMaintenanceActions(entry, context);
    });
    return retVal;
};
const de_ProvisionData = (output, context) => {
    return take(output, {
        DateNewProvisioningDataAvailable: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        DateProvisioned: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        IsNewProvisioningAvailable: __expectBoolean,
        ProvisionState: __expectString,
        ProvisionedCapacityUnits: __expectInt32,
        ReasonForNewProvisioningData: __expectString,
    });
};
const de_RdsConfiguration = (output, context) => {
    return take(output, {
        DeploymentOption: __expectString,
        EngineEdition: __expectString,
        EngineVersion: __expectString,
        InstanceMemory: __limitedParseDouble,
        InstanceType: __expectString,
        InstanceVcpu: __limitedParseDouble,
        StorageIops: __expectInt32,
        StorageSize: __expectInt32,
        StorageType: __expectString,
    });
};
const de_RdsRecommendation = (output, context) => {
    return take(output, {
        RequirementsToTarget: (_) => de_RdsRequirements(_, context),
        TargetConfiguration: (_) => de_RdsConfiguration(_, context),
    });
};
const de_RdsRequirements = (output, context) => {
    return take(output, {
        DeploymentOption: __expectString,
        EngineEdition: __expectString,
        EngineVersion: __expectString,
        InstanceMemory: __limitedParseDouble,
        InstanceVcpu: __limitedParseDouble,
        StorageIops: __expectInt32,
        StorageSize: __expectInt32,
    });
};
const de_RebootReplicationInstanceResponse = (output, context) => {
    return take(output, {
        ReplicationInstance: (_) => de_ReplicationInstance(_, context),
    });
};
const de_Recommendation = (output, context) => {
    return take(output, {
        CreatedDate: __expectString,
        Data: (_) => de_RecommendationData(_, context),
        DatabaseId: __expectString,
        EngineName: __expectString,
        Preferred: __expectBoolean,
        Settings: _json,
        Status: __expectString,
    });
};
const de_RecommendationData = (output, context) => {
    return take(output, {
        RdsEngine: (_) => de_RdsRecommendation(_, context),
    });
};
const de_RecommendationList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_Recommendation(entry, context);
    });
    return retVal;
};
const de_RefreshSchemasResponse = (output, context) => {
    return take(output, {
        RefreshSchemasStatus: (_) => de_RefreshSchemasStatus(_, context),
    });
};
const de_RefreshSchemasStatus = (output, context) => {
    return take(output, {
        EndpointArn: __expectString,
        LastFailureMessage: __expectString,
        LastRefreshDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ReplicationInstanceArn: __expectString,
        Status: __expectString,
    });
};
const de_Replication = (output, context) => {
    return take(output, {
        CdcStartPosition: __expectString,
        CdcStartTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        CdcStopPosition: __expectString,
        FailureMessages: _json,
        ProvisionData: (_) => de_ProvisionData(_, context),
        RecoveryCheckpoint: __expectString,
        ReplicationConfigArn: __expectString,
        ReplicationConfigIdentifier: __expectString,
        ReplicationCreateTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ReplicationDeprovisionTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ReplicationLastStopTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ReplicationStats: (_) => de_ReplicationStats(_, context),
        ReplicationType: __expectString,
        ReplicationUpdateTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        SourceEndpointArn: __expectString,
        StartReplicationType: __expectString,
        Status: __expectString,
        StopReason: __expectString,
        TargetEndpointArn: __expectString,
    });
};
const de_ReplicationConfig = (output, context) => {
    return take(output, {
        ComputeConfig: _json,
        ReplicationConfigArn: __expectString,
        ReplicationConfigCreateTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ReplicationConfigIdentifier: __expectString,
        ReplicationConfigUpdateTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ReplicationSettings: __expectString,
        ReplicationType: __expectString,
        SourceEndpointArn: __expectString,
        SupplementalSettings: __expectString,
        TableMappings: __expectString,
        TargetEndpointArn: __expectString,
    });
};
const de_ReplicationConfigList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ReplicationConfig(entry, context);
    });
    return retVal;
};
const de_ReplicationInstance = (output, context) => {
    return take(output, {
        AllocatedStorage: __expectInt32,
        AutoMinorVersionUpgrade: __expectBoolean,
        AvailabilityZone: __expectString,
        DnsNameServers: __expectString,
        EngineVersion: __expectString,
        FreeUntil: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        InstanceCreateTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        KmsKeyId: __expectString,
        MultiAZ: __expectBoolean,
        NetworkType: __expectString,
        PendingModifiedValues: _json,
        PreferredMaintenanceWindow: __expectString,
        PubliclyAccessible: __expectBoolean,
        ReplicationInstanceArn: __expectString,
        ReplicationInstanceClass: __expectString,
        ReplicationInstanceIdentifier: __expectString,
        ReplicationInstanceIpv6Addresses: _json,
        ReplicationInstancePrivateIpAddress: __expectString,
        ReplicationInstancePrivateIpAddresses: _json,
        ReplicationInstancePublicIpAddress: __expectString,
        ReplicationInstancePublicIpAddresses: _json,
        ReplicationInstanceStatus: __expectString,
        ReplicationSubnetGroup: _json,
        SecondaryAvailabilityZone: __expectString,
        VpcSecurityGroups: _json,
    });
};
const de_ReplicationInstanceList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ReplicationInstance(entry, context);
    });
    return retVal;
};
const de_ReplicationList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_Replication(entry, context);
    });
    return retVal;
};
const de_ReplicationStats = (output, context) => {
    return take(output, {
        ElapsedTimeMillis: __expectLong,
        FreshStartDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        FullLoadFinishDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        FullLoadProgressPercent: __expectInt32,
        FullLoadStartDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        StartDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        StopDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        TablesErrored: __expectInt32,
        TablesLoaded: __expectInt32,
        TablesLoading: __expectInt32,
        TablesQueued: __expectInt32,
    });
};
const de_ReplicationTableStatisticsList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_TableStatistics(entry, context);
    });
    return retVal;
};
const de_ReplicationTask = (output, context) => {
    return take(output, {
        CdcStartPosition: __expectString,
        CdcStopPosition: __expectString,
        LastFailureMessage: __expectString,
        MigrationType: __expectString,
        RecoveryCheckpoint: __expectString,
        ReplicationInstanceArn: __expectString,
        ReplicationTaskArn: __expectString,
        ReplicationTaskCreationDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ReplicationTaskIdentifier: __expectString,
        ReplicationTaskSettings: __expectString,
        ReplicationTaskStartDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ReplicationTaskStats: (_) => de_ReplicationTaskStats(_, context),
        SourceEndpointArn: __expectString,
        Status: __expectString,
        StopReason: __expectString,
        TableMappings: __expectString,
        TargetEndpointArn: __expectString,
        TargetReplicationInstanceArn: __expectString,
        TaskData: __expectString,
    });
};
const de_ReplicationTaskAssessmentResult = (output, context) => {
    return take(output, {
        AssessmentResults: __expectString,
        AssessmentResultsFile: __expectString,
        AssessmentStatus: __expectString,
        ReplicationTaskArn: __expectString,
        ReplicationTaskIdentifier: __expectString,
        ReplicationTaskLastAssessmentDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        S3ObjectUrl: __expectString,
    });
};
const de_ReplicationTaskAssessmentResultList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ReplicationTaskAssessmentResult(entry, context);
    });
    return retVal;
};
const de_ReplicationTaskAssessmentRun = (output, context) => {
    return take(output, {
        AssessmentProgress: _json,
        AssessmentRunName: __expectString,
        LastFailureMessage: __expectString,
        ReplicationTaskArn: __expectString,
        ReplicationTaskAssessmentRunArn: __expectString,
        ReplicationTaskAssessmentRunCreationDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ResultEncryptionMode: __expectString,
        ResultKmsKeyArn: __expectString,
        ResultLocationBucket: __expectString,
        ResultLocationFolder: __expectString,
        ServiceAccessRoleArn: __expectString,
        Status: __expectString,
    });
};
const de_ReplicationTaskAssessmentRunList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ReplicationTaskAssessmentRun(entry, context);
    });
    return retVal;
};
const de_ReplicationTaskIndividualAssessment = (output, context) => {
    return take(output, {
        IndividualAssessmentName: __expectString,
        ReplicationTaskAssessmentRunArn: __expectString,
        ReplicationTaskIndividualAssessmentArn: __expectString,
        ReplicationTaskIndividualAssessmentStartDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Status: __expectString,
    });
};
const de_ReplicationTaskIndividualAssessmentList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ReplicationTaskIndividualAssessment(entry, context);
    });
    return retVal;
};
const de_ReplicationTaskList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ReplicationTask(entry, context);
    });
    return retVal;
};
const de_ReplicationTaskStats = (output, context) => {
    return take(output, {
        ElapsedTimeMillis: __expectLong,
        FreshStartDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        FullLoadFinishDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        FullLoadProgressPercent: __expectInt32,
        FullLoadStartDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        StartDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        StopDate: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        TablesErrored: __expectInt32,
        TablesLoaded: __expectInt32,
        TablesLoading: __expectInt32,
        TablesQueued: __expectInt32,
    });
};
const de_ResourcePendingMaintenanceActions = (output, context) => {
    return take(output, {
        PendingMaintenanceActionDetails: (_) => de_PendingMaintenanceActionDetails(_, context),
        ResourceIdentifier: __expectString,
    });
};
const de_SchemaResponse = (output, context) => {
    return take(output, {
        CodeLineCount: __expectLong,
        CodeSize: __expectLong,
        Complexity: __expectString,
        DatabaseInstance: _json,
        OriginalSchema: _json,
        SchemaId: __expectString,
        SchemaName: __expectString,
        Server: _json,
        Similarity: __limitedParseDouble,
    });
};
const de_StartReplicationResponse = (output, context) => {
    return take(output, {
        Replication: (_) => de_Replication(_, context),
    });
};
const de_StartReplicationTaskAssessmentResponse = (output, context) => {
    return take(output, {
        ReplicationTask: (_) => de_ReplicationTask(_, context),
    });
};
const de_StartReplicationTaskAssessmentRunResponse = (output, context) => {
    return take(output, {
        ReplicationTaskAssessmentRun: (_) => de_ReplicationTaskAssessmentRun(_, context),
    });
};
const de_StartReplicationTaskResponse = (output, context) => {
    return take(output, {
        ReplicationTask: (_) => de_ReplicationTask(_, context),
    });
};
const de_StopReplicationResponse = (output, context) => {
    return take(output, {
        Replication: (_) => de_Replication(_, context),
    });
};
const de_StopReplicationTaskResponse = (output, context) => {
    return take(output, {
        ReplicationTask: (_) => de_ReplicationTask(_, context),
    });
};
const de_TableStatistics = (output, context) => {
    return take(output, {
        AppliedDdls: __expectLong,
        AppliedDeletes: __expectLong,
        AppliedInserts: __expectLong,
        AppliedUpdates: __expectLong,
        Ddls: __expectLong,
        Deletes: __expectLong,
        FullLoadCondtnlChkFailedRows: __expectLong,
        FullLoadEndTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        FullLoadErrorRows: __expectLong,
        FullLoadReloaded: __expectBoolean,
        FullLoadRows: __expectLong,
        FullLoadStartTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Inserts: __expectLong,
        LastUpdateTime: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        SchemaName: __expectString,
        TableName: __expectString,
        TableState: __expectString,
        Updates: __expectLong,
        ValidationFailedRecords: __expectLong,
        ValidationPendingRecords: __expectLong,
        ValidationState: __expectString,
        ValidationStateDetails: __expectString,
        ValidationSuspendedRecords: __expectLong,
    });
};
const de_TableStatisticsList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_TableStatistics(entry, context);
    });
    return retVal;
};
const deserializeMetadata = (output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"],
});
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const throwDefaultError = withBaseException(__BaseException);
const buildHttpRpcRequest = async (context, headers, path, resolvedHostname, body) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const contents = {
        protocol,
        hostname,
        port,
        method: "POST",
        path: basePath.endsWith("/") ? basePath.slice(0, -1) + path : basePath + path,
        headers,
    };
    if (resolvedHostname !== undefined) {
        contents.hostname = resolvedHostname;
    }
    if (body !== undefined) {
        contents.body = body;
    }
    return new __HttpRequest(contents);
};
function sharedHeaders(operation) {
    return {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": `AmazonDMSv20160101.${operation}`,
    };
}
